<template>
  <div class="container">
    <div class="title-container">
      <div class="title-text">
        <h1 class="header-text">CSquare the blog</h1>
        <h2 class="footer-text">The Ghost theme</h2>
      </div>
    </div>
    <div class="blog-list">
      <div v-for="(blog, index) in posts" :key="index" @click="visitPage(blog)" class="cs-imgBox blog-card">
        <!-- <img :src="getBlogImg" alt=""> -->
        <div class="cs-container">
          <div class="cs-content">
            <h1>{{ blog.title }}</h1>
            <p>Description</p>
          </div>
        </div>
      </div>
      <!-- <a v-for="(blog, index) in posts" :key="index" @click="visitPage(blog)" class="blog-card">
        <article>
          <h3 class>{{ blog.title }}</h3>
          <h2>Description</h2>

          <p class="duration-text">4 min read</p>
        </article>
      </a> -->
    </div>
    <div class="loader-div">
      <Loading :centerLoader="page == 1" v-if="loading"/>
      <button @click="incrementPage" class="button button--load" aria-label="Load more images" v-else-if="checkCount">
        <svg class="polaroid" width="100%" height="100%" viewBox="0 0 220 243" preserveAspectRatio="xMidYMid meet">
          <rect class="polaroid__base" x="0" y="0" width="220" height="243" rx="5"></rect>
          <rect class="polaroid__inner" x="16" y="20" width="189" height="149"></rect>
          <g class="polaroid__loader">
            <circle cx="61.5" cy="94.5" r="17.5"></circle>
            <circle cx="110.5" cy="94.5" r="17.5"></circle>
            <circle cx="159.5" cy="94.5" r="17.5"></circle>
          </g>
        </svg>
        <span class="button__text">Load more</span>
      </button>
    </div>
  </div>
  <!-- <div class="section">
    <div class="container">
      <div class="flex cs-wrap">
      <div v-for="(blog, index) in posts" :key="index" class="blog-item flex cs-blue" v-bind:class="index == 1 || index == 8 ? 'large' : ''">
        <article @click="visitPage(blog)">
          <a href="javascript:void(0)" class="item-link-overlay">{{ blog.title }}</a>
        </article>
      </div>
      </div>
    </div>
    <div class="loader-div">
      <Loader :centerLoader="page == 1" v-if="loading"/>
      <button @click="incrementPage" class="button button--load" aria-label="Load more images" v-else-if="checkCount">
        <svg class="polaroid" width="100%" height="100%" viewBox="0 0 220 243" preserveAspectRatio="xMidYMid meet">
          <rect class="polaroid__base" x="0" y="0" width="220" height="243" rx="5"></rect>
          <rect class="polaroid__inner" x="16" y="20" width="189" height="149"></rect>
          <g class="polaroid__loader">
            <circle cx="61.5" cy="94.5" r="17.5"></circle>
            <circle cx="110.5" cy="94.5" r="17.5"></circle>
            <circle cx="159.5" cy="94.5" r="17.5"></circle>
          </g>
        </svg>
        <span class="button__text">Load more</span>
      </button>
    </div>
  </div> -->
</template>

<script>
import { GET_PAGINATE_POSTS_QUERY, CREATE_POST_MUTATION } from '@/graphql/queries/userQueries'
// import "@/assets/index.scss";
import Loading from '@/components/Loading'
import CoverImage from '@/assets/images/cover-image.jpg'
export default {
  name: 'Blog',
  props: {
    msg: String
  },
  components: {
    Loading
  },
  data: () => {
    return {
      posts: [],
      form: {
        title: null,
        content: null
      },
      loading: false,
      page: 1
    }
  },
  computed: {
    checkCount() {
      return this.posts.length % 5 == 0
    },
    getBlogImg() {
      return CoverImage
    }
  },
  created () {
    this.getPosts()
  },
  methods: {
    incrementPage() {
      this.page += 1
      this.getPosts()
    },
    encode(str) {
      return str.replace(/./g, function(c) {
        return ('00' + c.charCodeAt(0)).slice(-3);
      });
    },
    visitPage(blog) {
      const enStr = this.encode("en-" + blog.id)
      const array = blog.title.split(" ")
      array.push(enStr)
      const url = '/blog/' + array.join("-")
      this.$router.push(url)
    },
    getValue(x) {
      return x % 2
    },
    async getPosts() {
      console.log(this);
      const tempPosts = this.posts
      this.loading = true
      this.$apolloProvider.defaultClient.store.reset()
      const data = await this.$apollo.query({ query: GET_PAGINATE_POSTS_QUERY, variables: {per_page: 5, page: this.page}})
      this.posts = tempPosts.concat(data.data.paginatePosts)
      this.loading = false
      console.log("THis", this.posts);
    },
    async createPost() {
      const postCreated = await this.$apollo.mutate({
        mutation: CREATE_POST_MUTATION,
        variables: this.form
      })
      this.posts.push({title: this.form.title, content: this.form.content})
      console.log("Created Post", postCreated);
      this.form = {
        title: null,
        content: null
      }
    }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
  .button--load {
    outline: none;
    margin: 0;
    padding: 0;
    border: none;
    background: none;
    width: 7rem;
    cursor: pointer;
  }
  .polaroid {
    width: 2.5rem;
  }
  .polaroid__base {
    fill: #7579ec;
  }
  .polaroid__inner {
    fill: #e9ecef;
  }
  .button__text {
    display: block;
    font-size: 0.65em;
    font-weight: 900;
    display: block;
    margin: 0.85em 0 0 0;
    text-indent: 3px;
    letter-spacing: 3px;
    text-transform: uppercase;
    color:#7579ec;
  }
  .polaroid__loader circle {
    fill: #7579ec;
  }
  .button--load:hover .polaroid__loader circle {
    -webkit-animation: fadeInOut 0.3s ease-in infinite alternate forwards;
    animation: fadeInOut 0.3s ease-in infinite alternate forwards;
  }
  .button--load:hover .polaroid__loader circle:nth-child(2) {
    -webkit-animation-delay: 0.1s;
    animation-delay: 0.1s;
  }
  .button--load:hover .polaroid__loader circle:nth-child(3) {
    -webkit-animation-delay: 0.2s;
    animation-delay: 0.2s;
  }
  @keyframes fadeInOut {
      0% {
          opacity: 0;
      }
      100% {
          opacity: 1;
      }
  }
</style>
